diff --exclude=CVS --exclude=.cvsignore -Nur olsrd-0.5.3/src/plugin_util.c olsrd-current/src/plugin_util.c
--- olsrd-0.5.3/src/plugin_util.c	2007-07-20 14:25:56.000000000 +0200
+++ olsrd-current/src/plugin_util.c	2007-09-02 23:04:42.000000000 +0200
@@ -1,6 +1,7 @@
 /*
  * The olsr.org Optimized Link-State Routing daemon(olsrd)
  * Copyright (c) 2007, Bernd Petrovitsch <bernd@firmix.at>
+ * Copyright (c) 2007, Sven-Ola <sven-ola@gmx.de>
  * All rights reserved.
  *
  * Redistribution and use in source and binary forms, with or without 
@@ -36,14 +37,14 @@
  * to the project. For more information see the website or contact
  * the copyright holders.
  *
- * $Id: plugin_util.c,v 1.2 2007/07/20 12:25:56 bernd67 Exp $
+ * $Id: plugin_util.c,v 1.4 2007/09/02 21:04:42 bernd67 Exp $
  */
 
 #include "plugin_util.h"
 #include "olsr.h"
 #include "defs.h"
 
-int set_plugin_port(const char *value, void *data)
+int set_plugin_port(const char *value, void *data, unsigned int addon __attribute__((unused)))
 {
     char *endptr;
     const unsigned int port = strtoul(value, &endptr, 0);
@@ -65,7 +66,7 @@
     return 0;
 }
 
-int set_plugin_ipaddress(const char *value, void *data)
+int set_plugin_ipaddress(const char *value, void *data, unsigned int addon __attribute__((unused)))
 {
     char buf[INET6_ADDRSTRLEN];
     union olsr_ip_addr ip_addr;
@@ -85,7 +86,7 @@
 }
 
 
-int set_boolean(const char *value, void *data)
+int set_boolean(const char *value, void *data, unsigned int addon __attribute__((unused)))
 {
     int *v = data;
     if (strcasecmp (value, "yes") == 0) {
@@ -98,6 +99,40 @@
     return 0;
 }
 
+int set_plugin_int(const char *value, void *data, unsigned int addon __attribute__((unused)))
+{
+    char *endptr;
+    const int theint = strtol(value, &endptr, 0);
+    if (*endptr != '\0' || endptr == value) {
+        OLSR_PRINTF(0, "Illegal int \"%s\"", value);
+        return 1;
+    }
+    if (data != NULL) {
+        int *v = data;
+        *v = theint;
+        OLSR_PRINTF(1, "%s int %d\n", "Got", theint);
+    } else {
+        OLSR_PRINTF(0, "%s int %d\n", "Ignored", theint);
+    }
+    return 0;
+}
+
+int set_plugin_string(const char *value, void *data, unsigned int addon)
+{
+    if (data != NULL) {
+        char *v = data;
+        if (strlen(value) >= addon) {
+            OLSR_PRINTF(0, "String too long \"%s\"", value);
+            return 1;
+        }
+        strcpy(v, value);
+        OLSR_PRINTF(1, "%s string %s\n", "Got", value);
+    } else {
+        OLSR_PRINTF(0, "%s string %s\n", "Ignored", value);
+    }
+    return 0;
+}
+
 /*
  * Local Variables:
  * mode: c
diff --exclude=CVS --exclude=.cvsignore -Nur olsrd-0.5.3/src/plugin_util.h olsrd-current/src/plugin_util.h
--- olsrd-0.5.3/src/plugin_util.h	2007-07-15 19:46:46.000000000 +0200
+++ olsrd-current/src/plugin_util.h	2007-08-25 21:48:42.000000000 +0200
@@ -28,7 +28,7 @@
  *
  */
 
-/* $Id: plugin_util.h,v 1.1 2007/07/15 17:46:46 bernd67 Exp $ */
+/* $Id: plugin_util.h,v 1.2 2007/08/25 19:48:42 bernd67 Exp $ */
 
 /*
  * Example plugin for olsrd.org OLSR daemon
@@ -39,9 +39,11 @@
 #define _OLSRD_PLUGIN_UTIL
 
 /* Common/utility functions for plugins */
-int set_plugin_port(const char *value, void *data);
-int set_plugin_ipaddress(const char *value, void *data);
-int set_boolean(const char *value, void *data);
+int set_plugin_port(const char *value, void *data, unsigned int);
+int set_plugin_ipaddress(const char *value, void *data, unsigned int);
+int set_boolean(const char *value, void *data, unsigned int);
+int set_plugin_int(const char *value, void *data, unsigned int);
+int set_plugin_string(const char *value, void *data, unsigned int);
 
 
 #endif
diff --exclude=CVS --exclude=.cvsignore -Nur olsrd-0.5.3/src/print_packet.c olsrd-current/src/print_packet.c
--- olsrd-0.5.3/src/print_packet.c	2007-04-22 22:25:48.000000000 +0200
+++ olsrd-current/src/print_packet.c	2007-08-28 22:45:17.000000000 +0200
@@ -36,7 +36,7 @@
  * to the project. For more information see the website or contact
  * the copyright holders.
  *
- * $Id: print_packet.c,v 1.10 2007/04/22 20:25:48 bernd67 Exp $
+ * $Id: print_packet.c,v 1.11 2007/08/28 20:45:17 bernd67 Exp $
  */
 
 #include "print_packet.h"
@@ -109,7 +109,7 @@
   fprintf(handle, "    Type: %s, size: %d, vtime: %0.2f\n", 
 	  olsr_msgtype_to_string(msg->v4.olsr_msgtype), 
 	  ntohs(msg->v4.olsr_msgsize),
-	  ME_TO_DOUBLE(msg->v4.olsr_vtime));
+	  me_to_double(msg->v4.olsr_vtime));
   fprintf(handle, "    TTL: %d, Hopcnt: %d, seqno: %d\n",
 	  (olsr_cnf->ip_version == AF_INET) ? msg->v4.ttl : msg->v6.ttl,
 	  (olsr_cnf->ip_version == AF_INET) ? msg->v4.hopcnt : msg->v6.hopcnt,
@@ -192,7 +192,7 @@
   union olsr_ip_addr *haddr;
   int hellosize = totsize - ((olsr_cnf->ip_version == AF_INET) ? OLSR_MSGHDRSZ_IPV4 : OLSR_MSGHDRSZ_IPV6);
 
-  fprintf(handle, "    +Htime: %0.2f\n", ME_TO_DOUBLE(data[2]));
+  fprintf(handle, "    +Htime: %0.2f\n", me_to_double(data[2]));
 
   fprintf(handle, "    +Willingness: %d\n", data[3]);
 
@@ -259,7 +259,7 @@
   union olsr_ip_addr *haddr;
   int hellosize = totsize - ((olsr_cnf->ip_version == AF_INET) ? OLSR_MSGHDRSZ_IPV4 : OLSR_MSGHDRSZ_IPV6);
 
-  fprintf(handle, "    +Htime: %0.2f\n", ME_TO_DOUBLE(data[2]));
+  fprintf(handle, "    +Htime: %0.2f\n", me_to_double(data[2]));
 
   fprintf(handle, "    +Willingness: %d\n", data[3]);
 
diff --exclude=CVS --exclude=.cvsignore -Nur olsrd-0.5.3/src/process_package.c olsrd-current/src/process_package.c
--- olsrd-0.5.3/src/process_package.c	2007-04-26 00:08:13.000000000 +0200
+++ olsrd-current/src/process_package.c	2007-08-03 00:07:19.000000000 +0200
@@ -36,7 +36,7 @@
  * to the project. For more information see the website or contact
  * the copyright holders.
  *
- * $Id: process_package.c,v 1.40 2007/04/25 22:08:13 bernd67 Exp $
+ * $Id: process_package.c,v 1.41 2007/08/02 22:07:19 bernd67 Exp $
  */
 
 
@@ -86,7 +86,7 @@
   /*
    * Update link status
    */
-  struct link_entry         *link = update_link_entry(&in_if->ip_addr, from_addr, message, in_if);
+  struct link_entry *lnk = update_link_entry(&in_if->ip_addr, from_addr, message, in_if);
 
   if (olsr_cnf->lq_level > 0)
     {
@@ -94,7 +94,7 @@
       double rel_lq;
       struct hello_neighbor *walker;
       // just in case our neighbor has changed its HELLO interval
-      olsr_update_packet_loss_hello_int(link, message->htime);
+      olsr_update_packet_loss_hello_int(lnk, message->htime);
 
       // find the input interface in the list of neighbor interfaces
 
@@ -104,7 +104,7 @@
 
       // the current reference link quality
 
-      saved_lq = link->saved_neigh_link_quality;
+      saved_lq = lnk->saved_neigh_link_quality;
 
       if (saved_lq == 0.0)
         saved_lq = -1.0;
@@ -113,19 +113,19 @@
       // know the link quality in both directions
 
       if (walker != NULL)
-        link->neigh_link_quality = walker->link_quality;
+        lnk->neigh_link_quality = walker->link_quality;
 
       else
-        link->neigh_link_quality = 0.0;
+        lnk->neigh_link_quality = 0.0;
 
       // if the link quality has changed by more than 10 percent,
       // print the new link quality table
 
-      rel_lq = link->neigh_link_quality / saved_lq;
+      rel_lq = lnk->neigh_link_quality / saved_lq;
 
       if (rel_lq > 1.1 || rel_lq < 0.9)
         {
-          link->saved_neigh_link_quality = link->neigh_link_quality;
+          lnk->saved_neigh_link_quality = lnk->neigh_link_quality;
 
           if (olsr_cnf->lq_dlimit > 0)
           {
@@ -145,7 +145,7 @@
         }
     }
   
-  neighbor = link->neighbor;
+  neighbor = lnk->neighbor;
 
   /*
    * Hysteresis
@@ -154,13 +154,13 @@
     {
       /* Update HELLO timeout */
       //printf("MESSAGE HTIME: %f\n", message->htime);
-      olsr_update_hysteresis_hello(link, message->htime);
+      olsr_update_hysteresis_hello(lnk, message->htime);
     }
 
   /* Check if we are chosen as MPR */
   if(olsr_lookup_mpr_status(message, in_if))
     /* source_addr is always the main addr of a node! */
-    olsr_update_mprs_set(&message->source_addr, (float)message->vtime);
+    olsr_update_mprs_set(&message->source_addr, message->vtime);
 
 
 
@@ -624,10 +624,10 @@
 
   if (olsr_cnf->lq_level > 0)
     {
-      struct link_entry *link =
+      struct link_entry *lnk =
         get_best_link_to_neighbor(&neighbor->neighbor_main_addr);
 
-      if(!link)
+      if(!lnk)
 	return;
 
       // Second pass for link quality OLSR: calculate the best 2-hop
@@ -695,7 +695,7 @@
 
                       new_path_link_quality =
                         new_second_hop_link_quality *
-                        link->loss_link_quality * link->neigh_link_quality;
+                        lnk->loss_link_quality * lnk->neigh_link_quality;
 
                       // Only copy the link quality if it is better than what we have
                       // for this 2-hop neighbor
diff --exclude=CVS --exclude=.cvsignore -Nur olsrd-0.5.3/src/process_routes.c olsrd-current/src/process_routes.c
--- olsrd-0.5.3/src/process_routes.c	2007-05-14 00:23:55.000000000 +0200
+++ olsrd-current/src/process_routes.c	2007-08-03 00:07:19.000000000 +0200
@@ -39,7 +39,7 @@
  * to the project. For more information see the website or contact
  * the copyright holders.
  *
- * $Id: process_routes.c,v 1.33 2007/05/13 22:23:55 bernd67 Exp $
+ * $Id: process_routes.c,v 1.34 2007/08/02 22:07:19 bernd67 Exp $
  */
 
 #include "defs.h"
@@ -213,14 +213,14 @@
 int
 olsr_init_old_table(void)
 {
-  int index;
+  int idx;
 
-  for(index=0;index<HASHSIZE;index++)
+  for(idx=0;idx<HASHSIZE;idx++)
     {
-      old_routes[index].next = &old_routes[index];
-      old_routes[index].prev = &old_routes[index];
-      old_hna[index].next = &old_hna[index];
-      old_hna[index].prev = &old_hna[index];
+      old_routes[idx].next = &old_routes[idx];
+      old_routes[idx].prev = &old_routes[idx];
+      old_hna[idx].next = &old_hna[idx];
+      old_hna[idx].prev = &old_hna[idx];
     }
 
   return 1;
@@ -277,12 +277,12 @@
 {
   struct destination_n *kernel_route_list = NULL;
   struct rt_entry      *destination;
-  olsr_u8_t            index;
+  int                   idx;
   
-  for(index=0;index<HASHSIZE;index++)
+  for(idx=0;idx<HASHSIZE;idx++)
     {
-      for(destination = from_table[index].next;
-	  destination != &from_table[index];
+      for(destination = from_table[idx].next;
+	  destination != &from_table[idx];
 	  destination = destination->next)
 	{
 	  if (!olsr_find_up_route(destination, in_table))
@@ -399,26 +399,26 @@
 void
 olsr_move_route_table(struct rt_entry *original, struct rt_entry *new)
 {
-  olsr_16_t index;
+  int idx;
 
-  for(index=0;index<HASHSIZE;index++)
+  for(idx=0;idx<HASHSIZE;idx++)
     {
-      if(original[index].next == &original[index])
+      if(original[idx].next == &original[idx])
 	{
-	  new[index].next = &new[index];
-	  new[index].prev = &new[index];
+	  new[idx].next = &new[idx];
+	  new[idx].prev = &new[idx];
 	}
       else
 	{
 	  /* Copy to old */
-	  new[index].next = original[index].next;
-	  new[index].next->prev = &new[index];
-	  new[index].prev = original[index].prev;
-	  new[index].prev->next = &new[index];
+	  new[idx].next = original[idx].next;
+	  new[idx].next->prev = &new[idx];
+	  new[idx].prev = original[idx].prev;
+	  new[idx].prev->next = &new[idx];
 
 	  /* Clear original */
-	  original[index].next = &original[index];
-	  original[index].prev = &original[index];
+	  original[idx].next = &original[idx];
+	  original[idx].prev = &original[idx];
 	}
     }
 }
diff --exclude=CVS --exclude=.cvsignore -Nur olsrd-0.5.3/src/rebuild_packet.c olsrd-current/src/rebuild_packet.c
--- olsrd-0.5.3/src/rebuild_packet.c	2007-04-26 00:08:13.000000000 +0200
+++ olsrd-current/src/rebuild_packet.c	2007-08-28 22:45:17.000000000 +0200
@@ -36,7 +36,7 @@
  * to the project. For more information see the website or contact
  * the copyright holders.
  *
- * $Id: rebuild_packet.c,v 1.21 2007/04/25 22:08:13 bernd67 Exp $
+ * $Id: rebuild_packet.c,v 1.22 2007/08/28 20:45:17 bernd67 Exp $
  */
 
 
@@ -87,7 +87,7 @@
       //printf("HNA from %s\n\n", olsr_ip_to_string((union olsr_ip_addr *)&hmsg->originator));
 
       /* Get vtime */
-      hmsg->vtime = ME_TO_DOUBLE(m->v4.olsr_vtime);
+      hmsg->vtime = me_to_double(m->v4.olsr_vtime);
 
       tmp_pairs = NULL;
       hna_pairs = NULL;
@@ -127,7 +127,7 @@
       hmsg->hop_count =  m->v6.hopcnt;
       
       /* Get vtime */
-      hmsg->vtime = ME_TO_DOUBLE(m->v6.olsr_vtime);
+      hmsg->vtime = me_to_double(m->v6.olsr_vtime);
       
       tmp_pairs = NULL;
       hna_pairs = NULL;
@@ -212,7 +212,7 @@
       mmsg->mid_addr = NULL;
 
       /* Get vtime */
-      mmsg->vtime = ME_TO_DOUBLE(m->v4.olsr_vtime);
+      mmsg->vtime = me_to_double(m->v4.olsr_vtime);
 
       //printf("Sequencenuber of MID from %s is %d\n", ip_to_string(&mmsg->addr), mmsg->mid_seqno);
 
@@ -262,7 +262,7 @@
       mmsg->mid_addr = NULL;
 
       /* Get vtime */
-      mmsg->vtime = ME_TO_DOUBLE(m->v6.olsr_vtime);
+      mmsg->vtime = me_to_double(m->v6.olsr_vtime);
 
       //printf("Sequencenuber of MID from %s is %d\n", ip_to_string(&mmsg->addr), mmsg->mid_seqno);
 
@@ -373,10 +373,10 @@
 
 
       /* Get vtime */
-      hmsg->vtime = ME_TO_DOUBLE(m->v4.olsr_vtime);
+      hmsg->vtime = me_to_double(m->v4.olsr_vtime);
 
       /* Get htime */
-      hmsg->htime = ME_TO_DOUBLE(m->v4.message.hello.htime);
+      hmsg->htime = me_to_double(m->v4.message.hello.htime);
 
       /* Willingness */
       hmsg->willingness = m->v4.message.hello.willingness;
@@ -417,10 +417,10 @@
       hmsg->packet_seq_number = ntohs(m->v6.seqno);
 
       /* Get vtime */
-      hmsg->vtime = ME_TO_DOUBLE(m->v6.olsr_vtime);
+      hmsg->vtime = me_to_double(m->v6.olsr_vtime);
 
       /* Get htime */
-      hmsg->htime = ME_TO_DOUBLE(m->v6.message.hello.htime);
+      hmsg->htime = me_to_double(m->v6.message.hello.htime);
 
       /* Willingness */
       hmsg->willingness = m->v6.message.hello.willingness;
@@ -496,7 +496,7 @@
 
 
       /* Get vtime */
-      tmsg->vtime = ME_TO_DOUBLE(m->v4.olsr_vtime);
+      tmsg->vtime = me_to_double(m->v4.olsr_vtime);
 
       OLSR_PRINTF(3, "Got TC vtime: %f\n", tmsg->vtime);
 
@@ -538,7 +538,7 @@
       /* Check if sender is symmetric neighbor here !! */
       
       /* Get vtime */
-      tmsg->vtime = ME_TO_DOUBLE(m->v6.olsr_vtime);
+      tmsg->vtime = me_to_double(m->v6.olsr_vtime);
 
       OLSR_PRINTF(3, "Got TC vtime: %f\n", tmsg->vtime);
 
diff --exclude=CVS --exclude=.cvsignore -Nur olsrd-0.5.3/src/routing_table.c olsrd-current/src/routing_table.c
--- olsrd-0.5.3/src/routing_table.c	2007-04-26 00:08:14.000000000 +0200
+++ olsrd-current/src/routing_table.c	2007-08-02 23:54:54.000000000 +0200
@@ -36,7 +36,7 @@
  * to the project. For more information see the website or contact
  * the copyright holders.
  *
- * $Id: routing_table.c,v 1.27 2007/04/25 22:08:14 bernd67 Exp $
+ * $Id: routing_table.c,v 1.28 2007/08/02 21:54:54 bernd67 Exp $
  */
 
 
@@ -85,7 +85,7 @@
 int
 olsr_init_routing_table(void)
 {
-  int index;
+  int idx;
   /*
    *The hna routes hash will almost always
    *be indexed to 0
@@ -93,12 +93,12 @@
    *with the functions used on the regular
    *routing table
    */
-  for(index=0;index<HASHSIZE;index++)
+  for(idx=0;idx<HASHSIZE;idx++)
     {
-      routingtable[index].next = &routingtable[index];
-      routingtable[index].prev = &routingtable[index];
-      hna_routes[index].next = &hna_routes[index];
-      hna_routes[index].prev = &hna_routes[index];
+      routingtable[idx].next = &routingtable[idx];
+      routingtable[idx].prev = &routingtable[idx];
+      hna_routes[idx].next = &hna_routes[idx];
+      hna_routes[idx].prev = &hna_routes[idx];
     }
   return 1;
 }
@@ -164,13 +164,13 @@
 void
 olsr_free_routing_table(struct rt_entry *table)
 {
-  olsr_u8_t       index;
+  int idx;
   
-  for(index=0;index<HASHSIZE;index++)
+  for(idx=0;idx<HASHSIZE;idx++)
     {
-      struct rt_entry *destination = table[index].next;
+      struct rt_entry *destination = table[idx].next;
 
-      while(destination != &table[index])
+      while(destination != &table[idx])
 	{
 	  struct rt_entry *dst_to_delete = destination;
 	  destination = destination->next;
@@ -192,18 +192,14 @@
  */
 struct rt_entry *
 olsr_insert_routing_table(union olsr_ip_addr *dst, 
-			  union olsr_ip_addr *router, 
+			  const union olsr_ip_addr *router, 
 			  struct interface *iface, 
 			  int metric,
 			  float etx)
 {
-  struct rt_entry *new_route_entry, *rt_list;
-  olsr_u32_t       hash;
-
-  hash = olsr_hashing(dst);
-  rt_list = &routingtable[hash];
-
-  new_route_entry = olsr_malloc(sizeof(struct rt_entry), "Insert routing table");
+  const olsr_u32_t hash = olsr_hashing(dst);
+  struct rt_entry *rt_list = &routingtable[hash];
+  struct rt_entry *new_route_entry = olsr_malloc(sizeof(struct rt_entry), "Insert routing table");
 
   COPY_IP(&new_route_entry->rt_dst, dst);
   COPY_IP(&new_route_entry->rt_router, router);
@@ -249,17 +245,17 @@
 static int
 olsr_fill_routing_table_with_neighbors(void)
 {
-  int index;
+  int idx;
 
 #ifdef DEBUG
   OLSR_PRINTF(7, "FILL ROUTING TABLE WITH NEIGHBORS\n");
 #endif
 
-  for(index=0;index<HASHSIZE;index++)
+  for(idx=0;idx<HASHSIZE;idx++)
     {
       struct neighbor_entry *neighbor;
-      for(neighbor = neighbortable[index].next;
-	  neighbor != &neighbortable[index];
+      for(neighbor = neighbortable[idx].next;
+	  neighbor != &neighbortable[idx];
 	  neighbor=neighbor->next)     
 	{
 	  if(neighbor->status == SYM)
@@ -276,18 +272,18 @@
 
 	      for(addrs2 = &addrs;addrs2!=NULL;addrs2 = addrs2->next_alias)
 		{
-		  struct link_entry *link = get_best_link_to_neighbor(&addrs2->alias);
+		  const struct link_entry *lnk = get_best_link_to_neighbor(&addrs2->alias);
 #ifdef DEBUG
 		  OLSR_PRINTF(7, "(ROUTE)Adding neighbor %s\n", olsr_ip_to_string(&addrs.alias));
 #endif
-		  if(link)
+		  if(lnk)
 		    {
-		      struct interface *iface = link->if_name ? if_ifwithname(link->if_name) :
-		                                if_ifwithaddr(&link->local_iface_addr);
+		      struct interface *iface = lnk->if_name ? if_ifwithname(lnk->if_name) :
+		                                if_ifwithaddr(&lnk->local_iface_addr);
 		      if(iface)
 			{
 			  olsr_insert_routing_table(&addrs2->alias, 
-						    &link->neighbor_iface_addr,
+						    &lnk->neighbor_iface_addr,
 						    iface,
 						    1,
 						    -1.0);
@@ -336,16 +332,16 @@
 olsr_fill_routing_table_with_two_hop_neighbors(void)
 {
   struct destination_n *list_destination_n=NULL;
-  int            index;
+  int            idx;
 
   //printf("FILL ROUTING TABLE WITH TWO HOP NEIGHBORS\n");
 
-  for(index=0;index<HASHSIZE;index++)
+  for(idx=0;idx<HASHSIZE;idx++)
     {
       struct neighbor_entry *neighbor;
 
-      for(neighbor = neighbortable[index].next;
-	  neighbor != &neighbortable[index];
+      for(neighbor = neighbortable[idx].next;
+	  neighbor != &neighbortable[idx];
 	  neighbor=neighbor->next)     
 	{
 	  struct neighbor_2_list_entry *neigh_2_list; 
@@ -386,19 +382,19 @@
 
 	      for(addrsp = &addrs; addrsp; addrsp = addrsp->next_alias)
 		{
-		  struct link_entry *link = get_best_link_to_neighbor(&neighbor->neighbor_main_addr);
+		  const struct link_entry * const lnk = get_best_link_to_neighbor(&neighbor->neighbor_main_addr);
 #ifdef DEBUG
 		  OLSR_PRINTF(7, "(ROUTE)Adding neighbor %s\n", olsr_ip_to_string(&addrsp->alias));
 #endif
-		  if(link)
+		  if(lnk)
 		    {
-                      struct interface *iface = link->if_name ? if_ifwithname(link->if_name) :
-		                                if_ifwithaddr(&link->local_iface_addr);
+                      struct interface *iface = lnk->if_name ? if_ifwithname(lnk->if_name) :
+		                                if_ifwithaddr(&lnk->local_iface_addr);
 		      if(iface)
 			{
 			  struct rt_entry *new_route_entry = 
 			    olsr_insert_routing_table(&addrsp->alias, 
-						      &link->neighbor_iface_addr,
+						      &lnk->neighbor_iface_addr,
 						      iface,
 						      2,
 						      -1.0);
@@ -550,14 +546,14 @@
 static struct rt_entry *
 olsr_check_for_higher_quality(struct rt_entry *routes, struct hna_net *net, float etx)
 {
-  int index;
+  int idx;
 
-  for(index=0;index<HASHSIZE;index++)
+  for(idx=0;idx<HASHSIZE;idx++)
     {
       struct rt_entry *tmp_routes;
       /* All entries */
-      for(tmp_routes = routes[index].next;
-	  tmp_routes != &routes[index];
+      for(tmp_routes = routes[idx].next;
+	  tmp_routes != &routes[idx];
 	  tmp_routes = tmp_routes->next)
 	{
 	  if(COMP_IP(&tmp_routes->rt_dst, &net->A_network_addr) &&
@@ -590,14 +586,14 @@
 struct rt_entry *
 olsr_check_for_lower_quality(struct rt_entry *routes, struct hna_net *net, float etx)
 {
-  int index;
+  int idx;
 
-  for(index=0;index<HASHSIZE;index++)
+  for(idx=0;idx<HASHSIZE;idx++)
     {
       struct rt_entry *tmp_routes;
       /* All entries */
-      for(tmp_routes = routes[index].next;
-	  tmp_routes != &routes[index];
+      for(tmp_routes = routes[idx].next;
+	  tmp_routes != &routes[idx];
 	  tmp_routes = tmp_routes->next)
 	{
 	  if(COMP_IP(&tmp_routes->rt_dst, &net->A_network_addr) &&
@@ -627,7 +623,7 @@
 void
 olsr_calculate_hna_routes(void)
 {
-  int index;
+  int idx;
 
 #ifdef DEBUG
   OLSR_PRINTF(3, "Calculating HNA routes\n");
@@ -635,12 +631,12 @@
 
   olsr_move_route_table(hna_routes, old_hna);
 
-  for(index=0;index<HASHSIZE;index++)
+  for(idx=0;idx<HASHSIZE;idx++)
     {
       struct hna_entry *tmp_hna;
       /* All entries */
-      for(tmp_hna = hna_set[index].next;
-	  tmp_hna != &hna_set[index];
+      for(tmp_hna = hna_set[idx].next;
+	  tmp_hna != &hna_set[idx];
 	  tmp_hna = tmp_hna->next)
 	{
 	  struct hna_net *tmp_net;
@@ -735,15 +731,15 @@
 void
 olsr_print_routing_table(struct rt_entry *table)
 {
-  int index;
+  int idx;
 
   printf("ROUTING TABLE\n");
   printf("DESTINATION\tNEXT HOP\tHOPCNT\tINTERFACE\n");
-  for(index = 0; index < HASHSIZE; index++)
+  for(idx = 0; idx < HASHSIZE; idx++)
     {
       struct rt_entry *destination;
-      for(destination = table[index].next;
-	  destination != &table[index];
+      for(destination = table[idx].next;
+	  destination != &table[idx];
 	  destination = destination->next)
 	{
 	  printf("%s\t", olsr_ip_to_string(&destination->rt_dst));
diff --exclude=CVS --exclude=.cvsignore -Nur olsrd-0.5.3/src/routing_table.h olsrd-current/src/routing_table.h
--- olsrd-0.5.3/src/routing_table.h	2005-11-17 00:55:54.000000000 +0100
+++ olsrd-current/src/routing_table.h	2007-08-02 23:54:54.000000000 +0200
@@ -36,7 +36,7 @@
  * to the project. For more information see the website or contact
  * the copyright holders.
  *
- * $Id: routing_table.h,v 1.17 2005/11/16 23:55:54 tlopatic Exp $
+ * $Id: routing_table.h,v 1.18 2007/08/02 21:54:54 bernd67 Exp $
  */
 
 #ifndef _OLSR_ROUTING_TABLE
@@ -107,7 +107,7 @@
 olsr_print_routing_table(struct rt_entry *);
 
 struct rt_entry *
-olsr_insert_routing_table(union olsr_ip_addr *, union olsr_ip_addr *, struct interface *, int, float);
+olsr_insert_routing_table(union olsr_ip_addr *, const union olsr_ip_addr *, struct interface *, int, float);
 
 struct rt_entry *
 olsr_lookup_routing_table(union olsr_ip_addr *);
diff --exclude=CVS --exclude=.cvsignore -Nur olsrd-0.5.3/src/scheduler.c olsrd-current/src/scheduler.c
--- olsrd-0.5.3/src/scheduler.c	2007-08-02 14:24:37.000000000 +0200
+++ olsrd-current/src/scheduler.c	2007-08-20 01:00:21.000000000 +0200
@@ -36,7 +36,7 @@
  * to the project. For more information see the website or contact
  * the copyright holders.
  *
- * $Id: scheduler.c,v 1.41 2007/08/02 12:24:37 bernd67 Exp $
+ * $Id: scheduler.c,v 1.42 2007/08/19 23:00:21 bernd67 Exp $
  */
 
 
@@ -52,11 +52,6 @@
 #include "olsr.h"
 #include "build_msg.h"
 
-#if defined WIN32
-extern olsr_bool olsr_win32_end_request;
-extern olsr_bool olsr_win32_end_flag;
-#endif
-
 /* Timer data, global. Externed in defs.h */
 clock_t now_times;              /* current idea of times(2) reported uptime */
 struct timeval now;		/* current idea of time */
diff --exclude=CVS --exclude=.cvsignore -Nur olsrd-0.5.3/src/tc_set.c olsrd-current/src/tc_set.c
--- olsrd-0.5.3/src/tc_set.c	2007-04-26 00:08:17.000000000 +0200
+++ olsrd-current/src/tc_set.c	2007-08-03 00:07:19.000000000 +0200
@@ -36,7 +36,7 @@
  * to the project. For more information see the website or contact
  * the copyright holders.
  *
- * $Id: tc_set.c,v 1.26 2007/04/25 22:08:17 bernd67 Exp $
+ * $Id: tc_set.c,v 1.27 2007/08/02 22:07:19 bernd67 Exp $
  */
 
 
@@ -57,15 +57,15 @@
 int
 olsr_init_tc(void)
 {
-  int index;
+  int idx;
   OLSR_PRINTF(5, "TC: init topo\n");
 
   olsr_register_timeout_function(&olsr_time_out_tc_set);
 
-  for(index=0;index<HASHSIZE;index++)
+  for(idx=0;idx<HASHSIZE;idx++)
     {
-      tc_table[index].next = &tc_table[index];
-      tc_table[index].prev = &tc_table[index];
+      tc_table[idx].next = &tc_table[idx];
+      tc_table[idx].prev = &tc_table[idx];
     }
 
   return 1;
@@ -372,16 +372,16 @@
 void
 olsr_time_out_tc_set(void)
 {
-  int index;
+  int idx;
 
-  for(index=0;index<HASHSIZE;index++)
+  for(idx=0;idx<HASHSIZE;idx++)
     {
       /* For all TC entries */
-      struct tc_entry *entry = tc_table[index].next;
-      while(entry != &tc_table[index])
+      struct tc_entry *entry = tc_table[idx].next;
+      while(entry != &tc_table[idx])
 	{
           struct tc_entry *entry2;
-	  //printf("INDEX: %d\n", index);
+	  //printf("INDEX: %d\n", idx);
 	  /* For all destination entries of that TC entry */
 	  int deleted = 0;
 	  struct topo_dst *dst_entry = entry->destinations.next;
diff --exclude=CVS --exclude=.cvsignore -Nur olsrd-0.5.3/src/two_hop_neighbor_table.c olsrd-current/src/two_hop_neighbor_table.c
--- olsrd-0.5.3/src/two_hop_neighbor_table.c	2007-04-26 00:08:17.000000000 +0200
+++ olsrd-current/src/two_hop_neighbor_table.c	2007-08-03 00:07:19.000000000 +0200
@@ -36,7 +36,7 @@
  * to the project. For more information see the website or contact
  * the copyright holders.
  *
- * $Id: two_hop_neighbor_table.c,v 1.18 2007/04/25 22:08:17 bernd67 Exp $
+ * $Id: two_hop_neighbor_table.c,v 1.19 2007/08/02 22:07:19 bernd67 Exp $
  */
 
 
@@ -56,12 +56,12 @@
 int
 olsr_init_two_hop_table(void)
 {
-  int index;
+  int idx;
 
-  for(index=0;index<HASHSIZE;index++)
+  for(idx=0;idx<HASHSIZE;idx++)
     {
-      two_hop_neighbortable[index].next = &two_hop_neighbortable[index];
-      two_hop_neighbortable[index].prev = &two_hop_neighbortable[index];
+      two_hop_neighbortable[idx].next = &two_hop_neighbortable[idx];
+      two_hop_neighbortable[idx].prev = &two_hop_neighbortable[idx];
     }
   return 1;
 }
diff --exclude=CVS --exclude=.cvsignore -Nur olsrd-0.5.3/src/unix/ifnet.c olsrd-current/src/unix/ifnet.c
--- olsrd-0.5.3/src/unix/ifnet.c	2007-05-14 00:23:55.000000000 +0200
+++ olsrd-current/src/unix/ifnet.c	2007-08-23 23:20:02.000000000 +0200
@@ -36,7 +36,7 @@
  * to the project. For more information see the website or contact
  * the copyright holders.
  *
- * $Id: ifnet.c,v 1.49 2007/05/13 22:23:55 bernd67 Exp $
+ * $Id: ifnet.c,v 1.51 2007/08/23 21:20:02 bernd67 Exp $
  */
 
 
@@ -704,15 +704,17 @@
   return 1;
 }
 
-static char basename[32];
-char* if_basename(char* name);
-char* if_basename(char* name)
+static char basenamestr[32];
+static const char* if_basename(const char* name);
+static const char* if_basename(const char* name)
 {
 	char *p = strchr(name, ':');
-	if (0 == p || p - name >= (int)(sizeof(basename) / sizeof(basename[0]) - 1)) return name;
-	memcpy(basename, name, p - name);
-	basename[p - name] = 0;
-	return basename;
+	if (NULL == p || p - name >= (int)(sizeof(basenamestr) / sizeof(basenamestr[0]) - 1)) {
+        	return name;
+        }
+	memcpy(basenamestr, name, p - name);
+	basenamestr[p - name] = 0;
+	return basenamestr;
 }
 
 /**
diff --exclude=CVS --exclude=.cvsignore -Nur olsrd-0.5.3/src/unix/misc.c olsrd-current/src/unix/misc.c
--- olsrd-0.5.3/src/unix/misc.c	2005-03-10 08:01:48.000000000 +0100
+++ olsrd-current/src/unix/misc.c	2007-08-02 23:58:43.000000000 +0200
@@ -36,7 +36,7 @@
  * to the project. For more information see the website or contact
  * the copyright holders.
  *
- * $Id: misc.c,v 1.5 2005/03/10 07:01:48 kattemat Exp $
+ * $Id: misc.c,v 1.6 2007/08/02 21:58:43 bernd67 Exp $
  */
 
 
@@ -47,30 +47,23 @@
 
 void clear_console(void)
 {
-  FILE *pipe;
-  static int first_time = 1;
+  static int len = -1;
   static char clear_buff[100];
-  static olsr_u16_t len = 0;
-  int c;
   int i;
 
-  if (first_time != 0)
+  if (len < 0)
     {
-      first_time = 0;
-
-      pipe = popen("clear", "r");
-
-      for (len = 0; len < sizeof (clear_buff); len++)
+      FILE *pip = popen("clear", "r");
+      for (len = 0; len < (int)sizeof(clear_buff); len++)
         {
-          c = fgetc(pipe);
-
+          int c = fgetc(pip);
           if (c == EOF)
             break;
 
-          clear_buff[len] = (char)c;
+          clear_buff[len] = c;
         }
 
-      pclose(pipe);
+      pclose(pip);
     }
 
   for (i = 0; i < len; i++)
